<template>
  <q-page class="row items-top justify-left">
    <div class="persons-wrapper">
      <PersonInList
        v-for="(person, index) in persons"
        :key="index"
        :selectUser="selectUser"
        :getFriends="getFriends"
        :person="person"
        :persons="persons"
        :index="index"
        :selectedPerson="selectedPerson"
        @userBlocked="
          () => {
            person.blocked = true;
          }
        "
        @userUnblocked="
          () => {
            person.blocked = false;
          }
        "
      />
    </div>
    <div
      @click="
        () => {
          eventBus.emit('scroll-to-bottom');
        }
      "
      v-if="isArrowVisible && selectedPerson?.nick"
      class="arrow-container"
    >
      <div class="content">
        <svg id="more-arrows">
          <polygon
            class="arrow-top"
            points="37.6,27.9 1.8,1.3 3.3,0 37.6,25.3 71.9,0 73.7,1.3 "
          />
          <polygon
            class="arrow-middle"
            points="37.6,45.8 0.8,18.7 4.4,16.4 37.6,41.2 71.2,16.4 74.5,18.7 "
          />
          <polygon
            class="arrow-bottom"
            points="37.6,64 0,36.1 5.1,32.8 37.6,56.8 70.4,32.8 75.5,36.1 "
          />
        </svg>
      </div>
    </div>
    <div>
      <TalksComponent v-if="selectedPerson" :selectedPerson="selectedPerson" />
    </div>
  </q-page>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { useRoute } from 'vue-router';

import Person from '../interfaces/Person';
import { useUserStore } from '../stores/user';
import { useSocketStore } from '../stores/socket';
import { api } from '../boot/axios';

import PersonInList from '../components/PersonInList.vue';
import TalksComponent from '../components/TalksComponent.vue';
import eventBus from 'src/eventBus';

import UnreceivedMessages from 'src/interfaces/UnreceivedMessages';

defineOptions({
  name: 'CommunicatorPage',
});

const route = useRoute();
const userStore = useUserStore();
const socketStore = useSocketStore();
const { user } = userStore;

const persons = ref<Person[]>([]);
const selectedPerson = ref<Person | null | undefined>();
const isArrowVisible = ref<boolean>(true);
eventBus.on('scrolled-to-bottom', () => {
  isArrowVisible.value = false;
});

eventBus.on('scrolled-to-top', () => {
  isArrowVisible.value = true;
});

getFriends();

eventBus.on(
  'unreceivedMessages',
  async (data: UnreceivedMessages | undefined) => {
    if (!data) return;
    await persons.value.forEach((el) => {
      if (data[el.nick]) {
        if (el.nrOfMessages) el.nrOfMessages += data[el.nick]?.length;
      }
    });
  }
);

eventBus.on('blocked', (person: string) => {
  const personFounded = persons.value.find((el) => el.nick === person);
  if (personFounded) {
    personFounded.blocks = true;
  }
});

eventBus.on('unblocked', (person: string) => {
  const personFounded = persons.value.find((el) => el.nick === person);
  if (personFounded) {
    personFounded.blocks = false;
  }
});

eventBus.on('loggedIn', (nick: string) => {
  const person = persons.value.find((person) => person.nick === nick);
  if (!person) return;
  person.loggedIn = true;
});

eventBus.on('loggedOut', (nick: string) => {
  const person = persons.value.find((person) => person.nick === nick);
  if (!person) return;
  person.loggedIn = false;
});

function selectUser(index: number) {
  selectedPerson.value = persons.value[index];
  resetMessages(selectedPerson.value);
}

function getFriend(nick: string) {
  api
    .post('/user/friend', { uuid: user.uuid, nick })
    .then(({ data }) => {
      console.log(data);
      persons.value.push(data);
      if (!selectedPerson.value) {
        selectedPerson.value = persons.value.at(-1);
      }
    })
    .catch((err) => {
      console.error(err);
    });
}

function resetMessages(person: Person) {
  socketStore.selectPerson(person.nick);
  socketStore.removeUserFromUnreadMessages(person.nick);
  eventBus.emit('unreceivedMessages');
  api.put('/message/read', {
    uuid: user.uuid,
    nick: person.nick,
  });
  countMessages(socketStore.unreceivedMessages);
}
function countMessages(unreceivedMesages: UnreceivedMessages) {
  persons.value.forEach((el) => {
    if (unreceivedMesages[el.nick]) {
      el.nrOfMessages = unreceivedMesages[el.nick]?.length || 0;
    } else {
      el.nrOfMessages = 0;
    }

    for (let i = 0, max = socketStore.unreadMessages.length; i < max; i++) {
      if (socketStore.unreadMessages[i].nick == el.nick) {
        if (typeof el.nrOfMessages === 'undefined') return;
        el.nrOfMessages += socketStore.unreadMessages[i].number || 0;
      }
    }
  });
}

function getFriends() {
  api
    .post('/user/friends', {
      uuid: user.uuid,
    })
    .then(async ({ data }) => {
      for (let i = 0, max = data.length; i < max; i++) {
        if (persons.value[i]) {
          persons.value[i] = { ...data[i], blocked: persons.value[i].blocked };
        } else {
          persons.value[i] = data[i];
        }
      }
      countMessages(socketStore.unreceivedMessages);
      if (route.query.nick) {
        selectedPerson.value = persons.value.find(
          (person) => person.nick === route.query.nick
        );
        if (!selectedPerson.value) {
          await getFriend(route.query.nick.toString());
          // persons.value.push(selectedPerson.value);
        }
      }
      resetMessages(selectedPerson.value || { nick: '' });
    });
}
</script>

<style scoped lang="scss">
.persons-wrapper {
  display: flex;
  flex-direction: column;
  margin: 20px;
}
.arrow-container {
  position: fixed;
  right: 200px;
  top: 150px;
  z-index: 2000;
}
#more-arrows {
  transform: scale(0.5) translateX(219px);
}
</style>
